diff -Naur gcc-2.95.3.old/gcc/glibc-include/time.h gcc-2.95.3/gcc/glibc-include/time.h
--- gcc-2.95.3.old/gcc/glibc-include/time.h	Thu Jan  1 03:00:00 1970
+++ gcc-2.95.3/gcc/glibc-include/time.h	Mon May 27 07:05:27 2002
@@ -0,0 +1,366 @@
+/* Copyright (C) 1991-1999, 2000, 2001 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Library General Public License as
+   published by the Free Software Foundation; either version 2 of the
+   License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Library General Public License for more details.
+
+   You should have received a copy of the GNU Library General Public
+   License along with the GNU C Library; see the file COPYING.LIB.  If not,
+   write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+   Boston, MA 02111-1307, USA.  */
+
+/*
+ *	ISO C99 Standard: 7.23 Date and time	<time.h>
+ */
+
+#ifndef	_TIME_H
+
+#if (! defined __need_time_t && !defined __need_clock_t && \
+     ! defined __need_timespec)
+# define _TIME_H	1
+# include <features.h>
+
+__BEGIN_DECLS
+
+#endif
+
+#ifdef	_TIME_H
+/* Get size_t and NULL from <stddef.h>.  */
+# define __need_size_t
+# define __need_NULL
+# include <stddef.h>
+
+/* This defines CLOCKS_PER_SEC, which is the number of processor clock
+   ticks per second.  */
+# include <bits/time.h>
+
+/* This is the obsolete POSIX.1-1988 name for the same constant.  */
+# if !defined __STRICT_ANSI__ && !defined __USE_XOPEN2K
+#  ifndef CLK_TCK
+#   define CLK_TCK	CLOCKS_PER_SEC
+#  endif
+# endif
+
+#endif /* <time.h> included.  */
+
+#if !defined __clock_t_defined && (defined _TIME_H || defined __need_clock_t)
+# define __clock_t_defined	1
+
+# include <bits/types.h>
+
+/* Returned by `clock'.  */
+typedef __clock_t clock_t;
+
+#endif /* clock_t not defined and <time.h> or need clock_t.  */
+#undef	__need_clock_t
+
+#if !defined __time_t_defined && (defined _TIME_H || defined __need_time_t)
+# define __time_t_defined	1
+
+# include <bits/types.h>
+
+/* Returned by `time'.  */
+typedef __time_t time_t;
+
+#endif /* time_t not defined and <time.h> or need time_t.  */
+#undef	__need_time_t
+
+#if !defined __clockid_t_defined && \
+   ((defined _TIME_H && defined __USE_POSIX199309) || defined __need_clockid_t)
+# define __clockid_t_defined	1
+
+# include <bits/types.h>
+
+/* Clock ID used in clock and timer functions.  */
+typedef __clockid_t clockid_t;
+
+#endif /* clockid_t not defined and <time.h> or need clockid_t.  */
+#undef	__clockid_time_t
+
+#if !defined __timer_t_defined && \
+    ((defined _TIME_H && defined __USE_POSIX199309) || defined __need_timer_t)
+# define __timer_t_defined	1
+
+# include <bits/types.h>
+
+/* Timer ID returned by `timer_create'.  */
+typedef __timer_t timer_t;
+
+#endif /* timer_t not defined and <time.h> or need timer_t.  */
+#undef	__need_timer_t
+
+
+#if !defined __timespec_defined && \
+    ((defined _TIME_H && defined __USE_POSIX199309) || defined __need_timespec)
+# define __timespec_defined	1
+
+/* POSIX.1b structure for a time value.  This is like a `struct timeval' but
+   has nanoseconds instead of microseconds.  */
+struct timespec
+  {
+    long int tv_sec;		/* Seconds.  */
+    long int tv_nsec;		/* Nanoseconds.  */
+  };
+
+#endif /* timespec not defined and <time.h> or need timespec.  */
+#undef	__need_timespec
+
+
+#ifdef	_TIME_H
+/* Used by other time functions.  */
+struct tm
+{
+  int tm_sec;			/* Seconds.	[0-60] (1 leap second) */
+  int tm_min;			/* Minutes.	[0-59] */
+  int tm_hour;			/* Hours.	[0-23] */
+  int tm_mday;			/* Day.		[1-31] */
+  int tm_mon;			/* Month.	[0-11] */
+  int tm_year;			/* Year	- 1900.  */
+  int tm_wday;			/* Day of week.	[0-6] */
+  int tm_yday;			/* Days in year.[0-365]	*/
+  int tm_isdst;			/* DST.		[-1/0/1]*/
+
+# ifdef	__USE_BSD
+  long int tm_gmtoff;		/* Seconds east of UTC.  */
+  __const char *tm_zone;	/* Timezone abbreviation.  */
+# else
+  long int __tm_gmtoff;		/* Seconds east of UTC.  */
+  __const char *__tm_zone;	/* Timezone abbreviation.  */
+# endif
+};
+
+
+#ifdef __USE_POSIX199309
+/* POSIX.1b structure for timer start values and intervals.  */
+struct itimerspec
+  {
+    struct timespec it_interval;
+    struct timespec it_value;
+  };
+
+/* We can use a simple forward declaration.  */
+struct sigevent;
+
+#endif	/* POSIX.1b */
+
+#ifdef __USE_XOPEN2K
+# ifndef __pid_t_defined
+typedef __pid_t pid_t;
+#  define __pid_t_defined
+# endif
+#endif
+
+
+/* Time used by the program so far (user time + system time).
+   The result / CLOCKS_PER_SECOND is program time in seconds.  */
+extern clock_t clock (void) __THROW;
+
+/* Return the current time and put it in *TIMER if TIMER is not NULL.  */
+extern time_t time (time_t *__timer) __THROW;
+
+/* Return the difference between TIME1 and TIME0.  */
+extern double difftime (time_t __time1, time_t __time0)
+     __THROW __attribute__ ((__const__));
+
+/* Return the `time_t' representation of TP and normalize TP.  */
+extern time_t mktime (struct tm *__tp) __THROW;
+
+
+/* Format TP into S according to FORMAT.
+   Write no more than MAXSIZE characters and return the number
+   of characters written, or 0 if it would exceed MAXSIZE.  */
+extern size_t strftime (char *__restrict __s, size_t __maxsize,
+			__const char *__restrict __format,
+			__const struct tm *__restrict __tp) __THROW;
+
+# ifdef __USE_XOPEN
+/* Parse S according to FORMAT and store binary time information in TP.
+   The return value is a pointer to the first unparsed character in S.  */
+extern char *strptime (__const char *__restrict __s,
+		       __const char *__restrict __fmt, struct tm *__tp)
+     __THROW;
+# endif
+
+
+/* Return the `struct tm' representation of *TIMER
+   in Universal Coordinated Time (aka Greenwich Mean Time).  */
+extern struct tm *gmtime (__const time_t *__timer) __THROW;
+
+/* Return the `struct tm' representation
+   of *TIMER in the local timezone.  */
+extern struct tm *localtime (__const time_t *__timer) __THROW;
+
+# if defined __USE_POSIX || defined __USE_MISC
+/* Return the `struct tm' representation of *TIMER in UTC,
+   using *TP to store the result.  */
+extern struct tm *gmtime_r (__const time_t *__restrict __timer,
+			    struct tm *__restrict __tp) __THROW;
+
+/* Return the `struct tm' representation of *TIMER in local time,
+   using *TP to store the result.  */
+extern struct tm *localtime_r (__const time_t *__restrict __timer,
+			       struct tm *__restrict __tp) __THROW;
+# endif	/* POSIX or misc */
+
+/* Return a string of the form "Day Mon dd hh:mm:ss yyyy\n"
+   that is the representation of TP in this format.  */
+extern char *asctime (__const struct tm *__tp) __THROW;
+
+/* Equivalent to `asctime (localtime (timer))'.  */
+extern char *ctime (__const time_t *__timer) __THROW;
+
+# if defined __USE_POSIX || defined __USE_MISC
+/* Reentrant versions of the above functions.  */
+
+/* Return in BUF a string of the form "Day Mon dd hh:mm:ss yyyy\n"
+   that is the representation of TP in this format.  */
+extern char *asctime_r (__const struct tm *__restrict __tp,
+			char *__restrict __buf) __THROW;
+
+/* Equivalent to `asctime_r (localtime_r (timer, *TMP*), buf)'.  */
+extern char *ctime_r (__const time_t *__restrict __timer,
+		      char *__restrict __buf) __THROW;
+# endif	/* POSIX or misc */
+
+
+/* Defined in localtime.c.  */
+extern char *__tzname[2];	/* Current timezone names.  */
+extern int __daylight;		/* If daylight-saving time is ever in use.  */
+extern long int __timezone;	/* Seconds west of UTC.  */
+
+
+# ifdef	__USE_POSIX
+/* Same as above.  */
+extern char *tzname[2];
+
+/* Set time conversion information from the TZ environment variable.
+   If TZ is not defined, a locale-dependent default is used.  */
+extern void tzset (void) __THROW;
+# endif
+
+# if defined __USE_SVID || defined __USE_XOPEN
+extern int daylight;
+extern long int timezone;
+# endif
+
+# ifdef __USE_SVID
+/* Set the system time to *WHEN.
+   This call is restricted to the superuser.  */
+extern int stime (__const time_t *__when) __THROW;
+# endif
+
+
+/* Nonzero if YEAR is a leap year (every 4 years,
+   except every 100th isn't, and every 400th is).  */
+# define __isleap(year)	\
+  ((year) % 4 == 0 && ((year) % 100 != 0 || (year) % 400 == 0))
+
+
+# ifdef __USE_MISC
+/* Miscellaneous functions many Unices inherited from the public domain
+   localtime package.  These are included only for compatibility.  */
+
+/* Like `mktime', but for TP represents Universal Time, not local time.  */
+extern time_t timegm (struct tm *__tp) __THROW;
+
+/* Another name for `mktime'.  */
+extern time_t timelocal (struct tm *__tp) __THROW;
+
+/* Return the number of days in YEAR.  */
+extern int dysize (int __year) __THROW  __attribute__ ((__const__));
+# endif
+
+
+# ifdef __USE_POSIX199309
+/* Pause execution for a number of nanoseconds.  */
+extern int nanosleep (__const struct timespec *__requested_time,
+		      struct timespec *__remaining) __THROW;
+
+
+/* Get resolution of clock CLOCK_ID.  */
+extern int clock_getres (clockid_t __clock_id, struct timespec *__res) __THROW;
+
+/* Get current value of clock CLOCK_ID and store it in TP.  */
+extern int clock_gettime (clockid_t __clock_id, struct timespec *__tp) __THROW;
+
+/* Set clock CLOCK_ID to value TP.  */
+extern int clock_settime (clockid_t __clock_id, __const struct timespec *__tp)
+     __THROW;
+
+#  ifdef __USE_XOPEN2K
+/* High-resolution sleep with the specified clock.  */
+extern int clock_nanosleep (clockid_t __clock_id, int __flags,
+			    __const struct timespec *__req,
+			    struct timespec *__rem) __THROW;
+
+/* Return clock ID for CPU-time clock.  */
+extern int clock_getcpuclockid (pid_t __pid, clockid_t *__clock_id) __THROW;
+#  endif
+
+
+/* Create new per-process timer using CLOCK_ID.  */
+extern int timer_create (clockid_t __clock_id,
+			 struct sigevent *__restrict __evp,
+			 timer_t *__restrict __timerid) __THROW;
+
+/* Delete timer TIMERID.  */
+extern int timer_delete (timer_t __timerid) __THROW;
+
+/* Set timer TIMERID to VALUE, returning old value in OVLAUE.  */
+extern int timer_settime (timer_t __timerid, int __flags,
+			  __const struct itimerspec *__restrict __value,
+			  struct itimerspec *__restrict __ovalue) __THROW;
+
+/* Get current value of timer TIMERID and store it in VLAUE.  */
+extern int timer_gettime (timer_t __timerid, struct itimerspec *__value)
+     __THROW;
+
+/* Get expiration overrun for timer TIMERID.  */
+extern int timer_getoverrun (timer_t __timerid) __THROW;
+# endif
+
+
+# ifdef __USE_XOPEN_EXTENDED
+/* Set to one of the following values to indicate an error.
+     1  the DATEMSK environment variable is null or undefined,
+     2  the template file cannot be opened for reading,
+     3  failed to get file status information,
+     4  the template file is not a regular file,
+     5  an error is encountered while reading the template file,
+     6  memory allication failed (not enough memory available),
+     7  there is no line in the template that matches the input,
+     8  invalid input specification Example: February 31 or a time is
+        specified that can not be represented in a time_t (representing
+	the time in seconds since 00:00:00 UTC, January 1, 1970) */
+extern int getdate_err;
+
+/* Parse the given string as a date specification and return a value
+   representing the value.  The templates from the file identified by
+   the environment variable DATEMSK are used.  In case of an error
+   `getdate_err' is set.  */
+extern struct tm *getdate (__const char *__string) __THROW;
+# endif
+
+# ifdef __USE_GNU
+/* Since `getdate' is not reentrant because of the use of `getdate_err'
+   and the static buffer to return the result in, we provide a thread-safe
+   variant.  The functionality is the same.  The result is returned in
+   the buffer pointed to by RESBUFP and in case of an error the return
+   value is != 0 with the same values as given above for `getdate_err'.  */
+extern int getdate_r (__const char *__restrict __string,
+		      struct tm *__restrict __resbufp) __THROW;
+# endif
+
+
+__END_DECLS
+
+#endif /* <time.h> included.  */
+
+#endif /* <time.h> not already included.  */
diff -Naur gcc-2.95.3.old/gcc/java/Make-lang.in gcc-2.95.3/gcc/java/Make-lang.in
--- gcc-2.95.3.old/gcc/java/Make-lang.in	Sat Jun 26 02:31:04 1999
+++ gcc-2.95.3/gcc/java/Make-lang.in	Mon May 27 07:05:27 2002
@@ -85,10 +85,10 @@
 		$(INCLUDES) $(srcdir)/java/jvspec.c
 
 # Create the compiler driver for $(GCJ).
-$(GCJ)$(exeext): gcc.o jvspec.o version.o \
+$(GCJ)$(exeext): gcc.o jvspec.o version.o find_cross.o cross_update_cpu.o \
 	   prefix.o intl.o $(LIBDEPS) $(EXTRA_GCC_OBJS)
 	$(CC) $(ALL_CFLAGS) $(LDFLAGS) -o $@ gcc.o jvspec.o prefix.o intl.o \
-	  version.o $(EXTRA_GCC_OBJS) $(LIBS)
+	  version.o find_cross.o cross_update_cpu.o $(EXTRA_GCC_OBJS) $(LIBS)
 
 # Create a version of the $(GCJ) driver which calls the cross-compiler.
 $(GCJ)-cross$(exeext): $(GCJ)$(exeext)
diff -Naur gcc-2.95.3.old/gcc/libgcc2.c gcc-2.95.3/gcc/libgcc2.c
--- gcc-2.95.3.old/gcc/libgcc2.c	Sat Jun 12 23:32:37 1999
+++ gcc-2.95.3/gcc/libgcc2.c	Mon May 27 07:05:27 2002
@@ -1080,7 +1080,7 @@
 #undef double
 #undef MIN
 #undef MAX
-#include <limits.h>
+#include <glimits.h>
 
 USItype
 __fixunsxfsi (XFtype a)
@@ -1102,7 +1102,7 @@
 #undef double
 #undef MIN
 #undef MAX
-#include <limits.h>
+#include <glimits.h>
 
 USItype
 __fixunsdfsi (DFtype a)
@@ -1124,7 +1124,7 @@
 #undef double
 #undef MIN
 #undef MAX
-#include <limits.h>
+#include <glimits.h>
 
 USItype
 __fixunssfsi (SFtype a)
diff -Naur gcc-2.95.3.old/gcc/prefix.c gcc-2.95.3/gcc/prefix.c
--- gcc-2.95.3.old/gcc/prefix.c	Thu May 20 14:51:36 1999
+++ gcc-2.95.3/gcc/prefix.c	Mon May 27 07:05:27 2002
@@ -292,6 +292,20 @@
   const char *path;
   const char *key;
 {
+//  int len = strlen(PREFIX);
+
+  /* If the path starts with default PREFIX and std_prefix was reset
+     change PREFIX to std_prefix */
+/*  if (strcmp(std_prefix, PREFIX) &&
+      ! strncmp (path, PREFIX, len))
+    {
+      char *new = xmalloc(strlen(std_prefix) + 
+                          strlen(path) - len + 1);
+      strcpy(new, std_prefix);
+      strcat(new, path + len);
+      path = new;
+    }
+*/
   if (! strncmp (path, std_prefix, strlen (std_prefix)) && key != 0)
     {
       if (key[0] != '$')
@@ -331,7 +345,6 @@
       path = new_path;
     }
 #endif
-
   return path;
 }
 
@@ -342,4 +355,9 @@
   int len;
 {
   std_prefix = save_string (prefix, len);
+}
+
+char *get_std_prefix()
+{
+  return std_prefix;
 }
diff -Naur gcc-2.95.3.old/gcc/protoize.c gcc-2.95.3/gcc/protoize.c
--- gcc-2.95.3.old/gcc/protoize.c	Thu May 20 14:51:36 1999
+++ gcc-2.95.3/gcc/protoize.c	Mon May 27 07:05:27 2002
@@ -91,6 +91,8 @@
 
 extern char *version_string;
 
+extern char *replace(char *, char*);
+
 /* Systems which are compatible only with POSIX 1003.1-1988 (but *not*
    with POSIX 1003.1-1990), e.g. Ultrix 4.2, might not have
    const qualifiers in the prototypes in the system include files.
@@ -239,42 +241,7 @@
 
 struct default_include { const char *fname; 
 			 const char *component;
-			 int x1, x2; } include_defaults[]
-#ifdef INCLUDE_DEFAULTS
-  = INCLUDE_DEFAULTS;
-#else
-  = {
-    /* Pick up GNU C++ specific include files.  */
-    { GPLUSPLUS_INCLUDE_DIR, "G++", 1, 1 },
-#ifdef CROSS_COMPILE
-    /* This is the dir for fixincludes.  Put it just before
-       the files that we fix.  */
-    { GCC_INCLUDE_DIR, "GCC", 0, 0 },
-    /* For cross-compilation, this dir name is generated
-       automatically in Makefile.in.  */
-    { CROSS_INCLUDE_DIR, 0, 0, 0 },
-    /* This is another place that the target system's headers might be.  */
-    { TOOL_INCLUDE_DIR, "BINUTILS", 0, 0 },
-#else /* not CROSS_COMPILE */
-    /* This should be /use/local/include and should come before
-       the fixincludes-fixed header files.  */
-    { LOCAL_INCLUDE_DIR, 0, 0, 1 },
-    /* This is here ahead of GCC_INCLUDE_DIR because assert.h goes here.
-       Likewise, behind LOCAL_INCLUDE_DIR, where glibc puts its assert.h.  */
-    { TOOL_INCLUDE_DIR, "BINUTILS", 0, 0 },
-    /* This is the dir for fixincludes.  Put it just before
-       the files that we fix.  */
-    { GCC_INCLUDE_DIR, "GCC", 0, 0 },
-    /* Some systems have an extra dir of include files.  */
-#ifdef SYSTEM_INCLUDE_DIR
-    { SYSTEM_INCLUDE_DIR, 0, 0, 0 },
-#endif
-    { STANDARD_INCLUDE_DIR, 0, 0, 0},
-#endif /* not CROSS_COMPILE */
-    { 0, 0, 0, 0}
-    };
-#endif /* no INCLUDE_DEFAULTS */
-
+			 int x1, x2; } include_defaults[10];
 /* Datatype for lists of directories or filenames.  */
 struct string_list
 {
@@ -4554,6 +4521,161 @@
   int longind;
   int c;
   const char *params = "";
+
+  /* Fill in the include_defaults array */
+#define add_to_include(_var, _fname, _component, _cplusplus, _cxx_aware) \
+  do { _var.fname     = _fname;      \
+       _var.component = _component;  \
+       _var.x1 = _cplusplus;         \
+       _var.x2 = _cxx_aware; } while (0);
+  int ind = 0;
+  char *cross_dir;
+  char *family_cpu;
+  
+  if (! find_family_cpu(&family_cpu)) {
+      notice ("%s: the CROSS_COMPILE environment variable is not set\n",
+          pname);
+      exit (FATAL_EXIT_CODE);
+  }
+
+  find_cross_dir(argv[0], &cross_dir, 0);
+  if (cross_dir)
+  {
+    add_to_include(include_defaults[ind],
+                   replace(cross_dir, GPLUSPLUS_INCLUDE_DIR),
+                   "G++", 1, 1);
+    ind++;
+#ifdef CROSS_COMPILE
+    add_to_include(include_defaults[ind],
+                   replace(cross_dir, GCC_INCLUDE_DIR),
+                   "GCC", 0, 0);
+    ind++;
+    add_to_include(include_defaults[ind],
+                   replace(cross_dir, CROSS_INCLUDE_DIR),
+                   "GCC", 0, 0);
+    ind++;
+
+#ifdef TOOL_INCLUDE_DIR
+    add_to_include(include_defaults[ind],
+                   replace(cross_dir, TOOL_INCLUDE_DIR),
+                   "BINUTILS", 0, 1);
+    ind++;
+#endif
+    {
+      char * target_include_dir = concat(cross_dir, "/../", 
+                                         family_cpu, "/usr/include", NULL_PTR);
+      char * gxx_target_include_dir = concat(cross_dir, "/../",
+                                         family_cpu, "/usr/include/g++-3",
+                                         NULL_PTR);
+      if (gxx_target_include_dir) {
+        add_to_include(include_defaults[ind], gxx_target_include_dir,
+                       0, 1, 1);
+        ind++;
+      }
+
+      if (target_include_dir) {
+        add_to_include(include_defaults[ind], target_include_dir,
+                       0, 0, 0);
+        ind++;
+      }
+    }
+#else /* not CROSS_COMPILE */
+#ifdef LOCAL_INCLUDE_DIR
+    add_to_include(include_defaults[ind],
+                   replace(cross_dir, LOCAL_INCLUDE_DIR), 0, 0, 1);
+    ind++;
+#endif
+#ifdef TOOL_INCLUDE_DIR
+    add_to_include(include_defaults[ind],
+                   replace(cross_dir, TOOL_INCLUDE_DIR),
+                   "BINUTILS", 0, 1);
+    ind++;
+#endif
+    add_to_include(include_defaults[ind],
+                   replace(cross_dir, GCC_INCLUDE_DIR),
+                   "GCC", 0, 0);
+    ind++;
+#ifdef SYSTEM_INCLUDE_DIR
+    add_to_include(include_defaults[ind],
+                   replace(cross_dir, SYSTEM_INCLUDE_DIR),
+                   0, 0, 0);
+    ind++;
+#endif
+#ifdef STANDARD_INCLUDE_DIR
+    add_to_include(include_defaults[ind],
+                   replace(cross_dir, STANDARD_INCLUDE_DIR),
+                   0, 0, 0);
+    ind++;
+#endif
+
+#endif /* not CROSS_COMPILE */
+  }
+  else
+  {
+    add_to_include(include_defaults[ind], GPLUSPLUS_INCLUDE_DIR,
+                   "G++", 1, 1);
+    ind++;
+#ifdef CROSS_COMPILE
+    add_to_include(include_defaults[ind], GCC_INCLUDE_DIR,
+                   "GCC", 0, 0);
+    ind++;
+    add_to_include(include_defaults[ind], CROSS_INCLUDE_DIR,
+                   "GCC", 0, 0);
+    ind++;
+
+#ifdef TOOL_INCLUDE_DIR
+    add_to_include(include_defaults[ind], TOOL_INCLUDE_DIR,
+                   "BINUTILS", 0, 1);
+    ind++;
+#endif
+    {
+      char * target_include_dir = concat(GCC_INCLUDE_DIR, "/../", 
+                                         family_cpu, "/usr/include", NULL_PTR);
+      char * gxx_target_include_dir = concat(GCC_INCLUDE_DIR, "/../", 
+                                         family_cpu, "/usr/include/g++-3",
+                                         NULL_PTR);
+      if (gxx_target_include_dir) {
+        add_to_include(include_defaults[ind], gxx_target_include_dir,
+                       0, 1, 1);
+        ind++;
+      }
+
+      if (target_include_dir) {
+        add_to_include(include_defaults[ind], target_include_dir,
+                       0, 0, 0);
+        ind++;
+      }
+    }
+#else /* not CROSS_COMPILE */
+#ifdef LOCAL_INCLUDE_DIR
+    add_to_include(include_defaults[ind], LOCAL_INCLUDE_DIR,
+                   0, 0, 1);
+    ind++;
+#endif
+#ifdef TOOL_INCLUDE_DIR
+    add_to_include(include_defaults[ind], TOOL_INCLUDE_DIR,
+                   "BINUTILS", 0, 1);
+    ind++;
+#endif
+    add_to_include(include_defaults[ind], GCC_INCLUDE_DIR,
+                   "GCC", 0, 0);
+    ind++;
+#ifdef SYSTEM_INCLUDE_DIR
+    add_to_include(include_defaults[ind], SYSTEM_INCLUDE_DIR,
+                   0, 0, 0);
+    ind++;
+#endif
+#ifdef STANDARD_INCLUDE_DIR
+    add_to_include(include_defaults[ind], STANDARD_INCLUDE_DIR,
+                   0, 0, 0);
+    ind++;
+#endif
+
+#endif /* not CROSS_COMPILE */
+  }
+    add_to_include(include_defaults[ind], 0, 0, 0, 0);
+
+#undef add_to_include
 
   pname = strrchr (argv[0], '/');
   pname = pname ? pname+1 : argv[0];
